#include "config.hh"
#include "confparser.hh"

static const char cfgfilename[] = "ircproxy.cfg";

const ConfParser::FieldType& GetConf(const char *sect, const char *var)
{
    static ConfParser config;
    static class ConfigLoader
    {
    public:
        ConfigLoader()
        {
            FILE* fp = fopen(cfgfilename, "rt");
            if(!fp)
            {
                perror(cfgfilename);
                return;
            }
            char Buf[8192];
            setvbuf(fp, Buf, _IOFBF, sizeof Buf);
            config.Parse(fp);
            fclose(fp);
        }
    } ConfigLoader;

    try
    {
        return config.FindField(sect, var);
    }
    catch(int n)
    {
        static const ConfParser::FieldType error;
        if(n == 1)
        {
            fprintf(stderr, "Error: [%s].%s not configured, section not found.\n", sect, var);
        }
        else if(n == 2)
        {
            fprintf(stderr, "Error: [%s].%s not configured, definition not found.\n", sect, var);
        }
        return error;
    }
}
